///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2019 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

namespace com.espertech.esper.common.@internal.type
{
    public class XYWHRectangle
    {
        public XYWHRectangle(
            double x,
            double y,
            double w,
            double h)
        {
            X = x;
            Y = y;
            W = w;
            H = h;
        }

        public double X;
        public double Y;
        public double W;
        public double H;

        public bool CoordinateEquals(
            double otherX,
            double otherY,
            double otherWidth,
            double otherHeight)
        {
            return X == otherX && Y == otherY && W == otherWidth && H == otherHeight;
        }

        protected bool Equals(XYWHRectangle other)
        {
            return X.Equals(other.X) && Y.Equals(other.Y) && W.Equals(other.W) && H.Equals(other.H);
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((XYWHRectangle) obj);
        }

        public override int GetHashCode()
        {
            unchecked {
                var hashCode = X.GetHashCode();
                hashCode = (hashCode * 397) ^ Y.GetHashCode();
                hashCode = (hashCode * 397) ^ W.GetHashCode();
                hashCode = (hashCode * 397) ^ H.GetHashCode();
                return hashCode;
            }
        }
    }
} // end of namespace